---
title: Detect WebGL
slug: Web/API/WebGL_API/By_example/Detect_WebGL
tags:
  - Beginner
  - Example
  - Graphics
  - Learn
  - Tutorial
  - WebGL
---
<div>{{IncludeSubnav("/en-US/Learn")}}</div>

<p>{{PreviousNext("Learn/WebGL/By_example","Learn/WebGL/By_example/Clearing_with_colors")}}</p>

<div id="detect-webgl">
<div class="summary">
<p><span class="seoSummary">This example demonstrates how to detect a {{Glossary("WebGL")}} rendering context and reports the result to the user.</span></p>
</div>

<p>{{EmbedLiveSample("detect-webgl-source",660,150)}}</p>

<div id="detect-webgl-intro">
<h3 id="Feature-detecting_WebGL">Feature-detecting WebGL</h3>

<p>In this first example we are going to check whether the browser supports {{Glossary("WebGL")}}. To that end we will try to obtain the {{domxref("WebGLRenderingContext","WebGL rendering context","",1)}} from a {{domxref("HTMLCanvasElement","canvas")}} element. The {{domxref("WebGLRenderingContext","WebGL rendering context", "", 1)}} is an interface, through which you can set and query the state of the graphics machine, send data to the WebGL, and execute draw commands.</p>

<p>Saving the state of the graphics machine within a single context interface is not unique to {{Glossary("WebGL")}}. This is also done in other graphics {̣{Glossary("API")}}, such as the {{domxref("CanvasRenderingContext2D","canvas 2D rendering context", "", 1)}}. However, the properties and variables you can tweak are different for each {{Glossary("API")}}.</p>
</div>

<div id="detect-webgl-source">
<pre class="brush: html notranslate">&lt;p&gt;[ Here would go the result of WebGL feature detection ]&lt;/p&gt;
&lt;button&gt;Press here to detect WebGLRenderingContext&lt;/button&gt;
</pre>

<pre class="brush: css notranslate">body {
  text-align : center;
}
button {
  display : block;
  font-size : inherit;
  margin : auto;
  padding : 0.6em;
}
</pre>

<pre class="brush: js notranslate">// Run everything inside window load event handler, to make sure
// DOM is fully loaded and styled before trying to manipulate it.
window.addEventListener("load", function() {
  var paragraph = document.querySelector("p"),
    button = document.querySelector("button");
  // Adding click event handler to button.
  button.addEventListener("click", detectWebGLContext, false);
  function detectWebGLContext () {
    // Create canvas element. The canvas is not added to the
    // document itself, so it is never displayed in the
    // browser window.
    var canvas = document.createElement("canvas");
    // Get WebGLRenderingContext from canvas element.
    var gl = canvas.getContext("webgl")
      || canvas.getContext("experimental-webgl");
    // Report the result.
    if (gl &amp;&amp; gl instanceof WebGLRenderingContext) {
      paragraph.textContent =
        "Congratulations! Your browser supports WebGL.";
    } else {
      paragraph.textContent = "Failed to get WebGL context. "
        + "Your browser or device may not support WebGL.";
    }
  }
}, false);
</pre>

<p>The source code of this example is also available on <a href="https://github.com/idofilin/webgl-by-example/tree/master/detect-webgl">GitHub</a>.</p>
</div>
</div>

<p>{{PreviousNext("Learn/WebGL/By_example","Learn/WebGL/By_example/Clearing_with_colors")}}</p>
